#!/usr/bin/env python

# Copyright 2005 PyTom <pytom@bishoujo.us>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


import Image, ImageChops
import sys
import os.path
import re

dollspath = os.path.join(os.path.dirname(sys.argv[0]), "dolls")

for dirname, dirlist, filelist in os.walk(dollspath):
    layers = { }

    for fn in filelist:
        realfn = os.path.join(dirname, fn)
        fn = fn.lower()

        if not fn.endswith(".png"):
            continue

        m = re.match(r'(([^_]+_[^_]+_[^_]+)(_[^-+]+)?([-+][\d.]+))(\.png)', fn)

        if not m:
            print "Ignoring:", fn
            continue

        spng = m.group(1) + ".spng"

        print "Writing:", spng


        im = Image.open(realfn)
        r, g, b, a = im.split()

        bbox = a.getbbox()
        cropped = im.crop(bbox)

        print spng, im.size, cropped.size

        f = file(os.path.join(dirname, spng), "wb")
        print >>f, "ALICE-SPNG-1"
        print >>f, im.size[0]
        print >>f, im.size[1]
        print >>f, bbox[0]
        print >>f, bbox[1]
        cropped.save(f, "PNG", optimize=9)
        f.close()
